' Unipolar Stepper Motor Test
' Copyright 2009 Raymond Allen
'
' I'm just playing around with a stepper motor here, trying to get microsteps to work!
' I'm just using a 12V supply and the ULN2803 to buffer the Prop pins [0,1,2,3]
' Video on this link shows operation: http://forums.parallax.com/forums/default.aspx?f=25&m=275728  
'
CON  'Constants Section

  _clkmode = xtal1 + pll16x      'using 5 MHz crystal in pll16x mode
  _xinfreq = 5_000_000           'to achieve 80 Mhz clock frequency 


OBJ  'Objects Section
    'We need the VGA (or TV) text driver
    
  text : "vga_text"    'For NTSC TV Video: Comment out this line...
  'text : "tv_text"    'and un-comment this line  (need to change pin parameter for text.start(pin) command below too).
  

var
  long stepcnt
  long a[1000]
  long b[1000]

  
PUB HelloWorld    'the first PUB routine is assumed the be the main one
  
  text.start(16)    'Start the VGA/TV text driver (uses another cog)
                    'The parameter (16) is the base pin used by demo and proto boards for VGA output
                    'Change (16) to (12) when using "tv_text" driver with demo board as it uses pin#12 for video

  text.str(string("Stepper Motor Test"))  'Output the string !

  'init
  DIRA[0..3]~~
  OUTA[0..3]~

  stepcnt:=clkfreq/10
  
  'FullStep
  'HalfStep
  'QuarterStep
  'WeakStep
  Microstep


PUB FullStep|i ,cnt1
  cnt1:=cnt+stepcnt
  repeat
    nstep(i++)
    waitcnt(cnt1)
    cnt1+=stepcnt 


PUB nStep(n)
  n:=n//4
  case n
    0:
      outa[0..3]:=%1100
    1:
      outa[0..3]:=%0110   
    2:
      outa[0..3]:=%0011   
    3:
      outa[0..3]:=%1001
    

PUB WeakStep|i

  repeat
    wstep(i++)
    waitcnt(cnt+stepcnt) 


PUB wStep(n)
  n:=n//4
  case n
    0:
      outa[0..3]:=%1000
    1:
      outa[0..3]:=%0100   
    2:
      outa[0..3]:=%0010   
    3:
      outa[0..3]:=%0001
      
PUB HalfStep|i

  repeat
    hstep(i++)
    waitcnt(cnt+stepcnt>>1) 


PUB hStep(n)
  'if n<0
  '  n+=8  
  n:=n//8
  case n
    0:
      outa[0..3]:=%1000
    1:
      outa[0..3]:=%1100   
    2:
      outa[0..3]:=%0100   
    3:
      outa[0..3]:=%0110
    4:
      outa[0..3]:=%0010
    5:
      outa[0..3]:=%0011   
    6:
      outa[0..3]:=%0001   
    7:
      outa[0..3]:=%1001


PUB QuarterStep|cnt1,i
  repeat
    hstep(i++)
    waitcnt(cnt+stepcnt>>2)
    cnt1:=cnt
    repeat until (cnt-cnt1)> (stepcnt>>2)
      hstep(i)
      waitcnt(cnt+10000)
      hstep(i-1)
      waitcnt(cnt+10000)
     

PUB MicroStep|cnt1,i,x ,j,k,msteps,cstep,tau1, tau2
  'really toggles at a fixed rate
  j:=0
  i:=1 'initial step
  msteps:=1+stepcnt/(clkfreq/100)  '50    '# of microsteps
  cStep:=(stepcnt>>1)/msteps-1400*msteps  'micro step time
  repeat               'step loop
    repeat k from 0 to msteps-1     'micro step loop
      tau1:=700+cStep*k/msteps
      tau2:=700+cStep*(msteps-k)/msteps  
      hstep(i)
      waitcnt(cnt+tau1)
      hstep(i-1)
      waitcnt(cnt+tau2)
    i++
        
        
      


                
cnt1:=cnt
    repeat until (cnt-cnt1)> (stepcnt>>1)
      x:=(cnt-cnt1)/((stepcnt>>1)>>14)
      'text.out(13)
      'text.dec(x)
      a[j]:=1500+x
      b[j]:=1500+(constant(1<<14)-x)
      
      hstep(i)
      waitcnt(cnt+1500+x)
      hstep(i-1)
      waitcnt(cnt+1500+(constant(1<<14)-x))
      j++
    repeat k from 0 to j-1
      text.out(13)
      text.dec(k)
      text.out(":")
      text.dec(a[k])
      text.out(",")
      text.dec(b[k])
    repeat
    i++
                    